# ffe

ffe: File/Folder Extensible manipulator
可轻松地用 Python 来写插件的文件操作工具

在日常使用电脑的过程中，总有一些关于文件/文件夹的操作是有规律、有重复性的，比如：

- 对调两个文件的文件名
- 批量修改文件名
- 把指定文件备份到指定文件夹，并自动改名
- 把指定文件移动到指定文件夹，并自动删除超过 n 天的旧文件
- 复制文件并且在复制结束后校验文件完整性
- 压缩、加密、上传文件
- 按你喜欢的方式单向/双向同步两个文件夹（具体就看扩展代码怎样写了）
- ……等等

举个例子，我最近经常需要对一个文件进行“压缩、加密、上传”操作，就写了相关插件，后面会详细解说这个插件（作为例子让大家有个直观了解），现在先说说 ffe 本身是什么。


## ffe 本身的功能

ffe 本身不解决任何具体问题，比如对文件进行改名、复制、移动等操作全部交给插件去做。

ffe 为你提供以下服务：

- install: 你只需要把插件代码放在 github 或 gitee 之类的仓库中，任何人都能使用 ffe install 命令来安装你写的插件。
- download: 正式安装插件前可先下载代码，审查后再安装。
- peek: 下载或安装插件前阅读插件的简单介绍。
- info: 查看插件的帮助文档。
- dump: 在执行任务前查看任务计划，并且可生成 toml 文件。
- dry run: 在正式执行任务前，安全地（不修改文件）预测运行结果。
- toml: 通过 toml 文件来输入参数，一个 toml 文件可包含多个任务，用 `ffe run -f <recipe.toml>` 命令即可一次性按顺序执行多个任务。
- proxy: 涉及网络操作时，可设置代理。

对于插件作者来说，只需要专注于具体的业务逻辑即可，按照套路填写一些信息后即可获得以上全部功能。

对于用户来说，可以在安装前查看插件简介，可批量安装插件，不同的插件可以组合使用。

另外, CLI 与 TOML 的配合效果很不错, TOML 很直观，容易编辑，比纯 CLI 更直观，又比 GUI 更容易编程开发。


## 安装方法


## 插件举例




dry_run 会尽量检查可能发生的错误，建议先 dry_run 一次。

Warning: Please download and inspect recipes before installing them.

提醒：请先下载 url 指向的文件，检查没有恶意代码后再安装，因为一旦安装，下次执行任何 ffe 命令都会自动执行其代码（自动 import）。

另外提供 recipes-gitee.toml

用户通过命令输入的 names 拥有最高优先级，但要注意一个 toml 文件包含多个任务，那么每个任务的 names 都会被命令行输入的 names 覆盖。

每个插件的简介里写明 dependencies, 另外专门做一个全部插件的 requirements.txt

处理 unicode 问题
